package cn.iocoder.yudao.module.mes.service.zjproduct;

import cn.iocoder.yudao.module.mes.dal.dataobject.paigongrecord.PaigongRecordDO;
import org.springframework.stereotype.Service;
import javax.annotation.Resource;
import org.springframework.validation.annotation.Validated;
import org.springframework.transaction.annotation.Transactional;

import java.util.*;
import cn.iocoder.yudao.module.mes.controller.admin.zjproduct.vo.*;
import cn.iocoder.yudao.module.mes.dal.dataobject.zjproduct.ZjProductDO;
import cn.iocoder.yudao.framework.common.pojo.PageResult;
import cn.iocoder.yudao.framework.common.pojo.PageParam;
import cn.iocoder.yudao.framework.common.util.object.BeanUtils;

import cn.iocoder.yudao.module.mes.dal.mysql.zjproduct.ZjProductMapper;

import static cn.iocoder.yudao.framework.common.exception.util.ServiceExceptionUtil.exception;
import static cn.iocoder.yudao.module.mes.enums.ErrorCodeConstants.*;

/**
 * 质量管理-质检参数 Service 实现类
 *
 * @author 内蒙必硕
 */
@Service
@Validated
public class ZjProductServiceImpl implements ZjProductService {

    @Resource
    private ZjProductMapper zjProductMapper;

    @Override
    public Long createZjProduct(ZjProductSaveReqVO createReqVO) {
        // 插入
        ZjProductDO zjProduct = BeanUtils.toBean(createReqVO, ZjProductDO.class);
        zjProductMapper.insert(zjProduct);
        // 返回
        return zjProduct.getId();
    }

    @Override
    public void updateZjProduct(ZjProductSaveReqVO updateReqVO) {
        // 校验存在
        validateZjProductExists(updateReqVO.getId());
        // 更新
        ZjProductDO updateObj = BeanUtils.toBean(updateReqVO, ZjProductDO.class);
        zjProductMapper.updateById(updateObj);
    }

    @Override
    public void deleteZjProduct(Long id) {
        // 校验存在
        validateZjProductExists(id);
        // 删除
        zjProductMapper.deleteById(id);
    }

    private void validateZjProductExists(Long id) {
        if (zjProductMapper.selectById(id) == null) {
            throw exception(ZJ_PRODUCT_NOT_EXISTS);
        }
    }

    @Override
    public ZjProductDO getZjProduct(Long id) {
        return zjProductMapper.selectById(id);
    }

    @Override
    public PageResult<ZjProductDO> getZjProductPage(ZjProductPageReqVO pageReqVO) {
        return zjProductMapper.selectPage(pageReqVO);
    }

    @Override
    public List<ZjProductDO> getZjProductByProductId(Long productId) {
        return zjProductMapper.selectListByProductId(productId);
    }

}